--
-- Bremse
-- Class for all Dolly Trailers
--
-- @author  Jack
-- @date  25/04/09
--
-- Copyright (C) Jack
-- Modify by Brndi

Bremse = {};

function Bremse.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;


function Bremse:load(xmlFile)

-- Bremslichter
    self.numbrakelights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.brakelights#count"), 0);
    self.brakelights = {};
    for i=1, self.numbrakelights do
        local brakelightnamei = string.format("vehicle.brakelights.brakelight" .. "%d", i);
        self.brakelights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, brakelightnamei .. "#index"));
        setVisibility(self.brakelights[i], false);
    end;

    self.brakelightsActive = false;
    self.braking = false;
    self.attached = true;
    self.isBremse = true;
    self.delayOff = 0;
    self.delayOffLeft = 0;
    self.delayOffRight = 0;
end;

function Bremse:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Bremse:keyEvent(unicode, sym, modifier, isDown)
end;

function Bremse:update(dt)

	-- Bremslicht
		local inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);

		if self.attacherVehicle ~= nil then
			if self.brakelightsActive then
				for i=1, self.numbrakelights do
					local brakelight = self.brakelights[i];
					setVisibility(brakelight, self.brakelightsActive);
				end;
			else
				for i=1, self.numbrakelights do
					local brakelight = self.brakelights[i];
					setVisibility(brakelight, self.brakelightsActive, false);
				end;
			end;
			if (self.attacherVehicle.movingDirection*self.attacherVehicle.lastSpeed*(-inputAxisY)) < -0.001 then		
				self.brakelightsActive = true;
				self.braking = true;
			else
				self.brakelightsActive = false;
				self.braking = false;
			end;
		end;
end;

function Bremse:draw()
end;

function Bremse:delete()
end;