--
-- Zapfwelle
-- Specialization for Zapfwelle
--
-- @author  Manuel Leithner
-- @date  26/07/09
--

Zapfwelle = {};

function Zapfwelle.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function Zapfwelle:load(xmlFile)
	
	self.Zapfwelle = {};		
	self.Zapfwelle.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Zapfwelle#index"));
	local x,y,z = getRotation(self.Zapfwelle.node);
	self.Zapfwelle.rot = {x,y,z};
	self.Zapfwelle.part = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Zapfwelle#part"));
	x,y,z = getTranslation(self.Zapfwelle.part);
	self.Zapfwelle.trans = {x,y,z};
	self.Zapfwelle.fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Zapfwelle#fixPoint"));
	local ax, ay, az = getWorldTranslation(self.Zapfwelle.part);
	local bx, by, bz = getWorldTranslation(self.Zapfwelle.fixPoint);		
	self.Zapfwelle.distance = Utils.vector3Length(ax-bx, ay-by, az-bz);	

	self.attacherVehicleZapfwelle = nil;
	self.doJointSearch = false;
	
end;

function Zapfwelle:delete()
end;

function Zapfwelle:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Zapfwelle:keyEvent(unicode, sym, modifier, isDown)
end;

function Zapfwelle:update(dt)
	
	if self.doJointSearch then
		for i=1, table.getn(self.attacherVehicle.attachedImplements) do
			if self.attacherVehicle.attachedImplements[i].object == self then			
				local index = self.attacherVehicle.attachedImplements[i].jointDescIndex;
				local joint = self.attacherVehicle.attacherJoints[index];	
				if joint.ZapfwelleAttacher ~= nil then
					self.attacherVehicleZapfwelle = joint.ZapfwelleAttacher;
					break;	
				end;
			end;
		end;
		self.doJointSearch = false;
	end;
	
	if self:getIsActive() then		
			
		if self.attacherVehiclePZapfwelle ~= nil then		
			local ax, ay, az = getWorldTranslation(self.Zapfwelle.node);
			local bx, by, bz = getWorldTranslation(self.attacherVehicleZapfwelle);
			local x, y, z = worldDirectionToLocal(getParent(self.Zapfwelle.node), bx-ax, by-ay, bz-az);
			setDirection(self.Zapfwelle.node, x, y, z, 0, -1, 0);
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.Zapfwelle.part, 0, 0, distance-self.Zapfwelle.distance);		
		end;		
	end;
	
end;

function Zapfwelle:draw()
end;


function Zapfwelle:onAttach(attacherVehicle)
	self.doJointSearch = true;
end;

function Zapfwelle:onDetach()
	setTranslation(self.Zapfwelle.part, unpack(self.Zapfwelle.trans));
	setRotation(self.Zapfwelle.node, unpack(self.Zapfwelle.rot));
	self.attacherVehicleZapfwelle = nil;
end;




